#!/usr/bin/env bash

USAGE="[<remote>] [--no-topic] [--dry-run] [--]"
OPTIONS_SPEC=
SUBDIRECTORY_OK=Yes
. "$(git --exec-path)/git-sh-setup"

#-----------------------------------------------------------------------------

remote=''
refspecs=''
no_topic=''
dry_run=''

# Parse the command line options.
while test $# != 0; do
  case "$1" in
    --no-topic) no_topic=1 ;;
    --dry-run)  dry_run=--dry-run ;;
    --) shift; break ;;
    -*) usage ;;
    *) test -z "$remote" || usage ; remote="$1" ;;
  esac
  shift
done
test $# = 0 || usage

# Default remote.
test -n "$remote" || remote="gerrit"

if test -z "$no_topic"; then
  # Identify and validate the topic branch name.
  topic="$(git symbolic-ref HEAD | sed -e 's|^refs/heads/||')"
  if test "$topic" = "master"; then
    die 'Please name your topic:
    git checkout -b descriptive-name'
  fi
  refspecs="HEAD:refs/for/master/$topic"
fi

# Exit early if we have nothing to push.
if test -z "$refspecs"; then
  echo "Nothing to push!"
  exit 0
fi

# Fetch the current upstream master branch head.
# This helps the computation of a minimal pack to push.
echo "Fetching $remote master"
fetch_out=$(git fetch "$remote" master 2>&1) || die "$fetch_out"

# Push.  Save output and exit code.
echo "Pushing to $remote"
push_stdout=$(git push --porcelain $dry_run "$remote" $refspecs); push_exit=$?
echo "$push_stdout"

# Reproduce the push exit code.
exit $push_exit
